"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
const Path = require("path");
const util_1 = require("util");
let MAP = {};
let POINTS;
const mapdule = (name) => MAP[name] ? require(MAP[name]) : undefined;
const set = (name, target) => { MAP[name] = target; };
const load = (setup = {}) => {
    const map = setup.map || {};
    const points = setup.points || {};
    Object.keys(map).forEach(name => set(name, map[name]));
    Object.keys(points).forEach(point => from(point).set(points[point]));
};
const from = (point) => ({
    set: (path) => {
        if (util_1.isNullOrUndefined(point)) {
            return undefined;
        }
        const absolute = Path.isAbsolute(path) ? path : Path.resolve(path);
        POINTS[point] = absolute;
        return absolute;
    },
    to: (to) => {
        const initial = util_1.isNullOrUndefined(point) ? Path.resolve(".") : POINTS[point];
        const target = Path.resolve(initial, to);
        return require(target);
    },
});
const reset = () => {
    MAP = {};
    POINTS = {};
};
module.exports = mapdule;
module.exports.set = set;
module.exports.load = load;
module.exports.from = from;
module.exports.reset = reset;
//# sourceMappingURL=index.js.map